<?php
function base64url_encode($str)
{
    return rtrim(strtr(base64_encode($str), '+/', '-_'), '=');
}

function generate_jwt_token($payload, $secret = 'nkvi8tOXLfQAaEJuxOveZGHpibvWpKp-2ut8xTNz2rM')
{
    $payload->iat = time();
    $payload->exp = time()+120;

    $headers = ['alg'=>'HS256','typ'=>'JWT'];
    $headers_encoded = base64_encode(json_encode($headers));

    $payload_encoded = base64_encode(json_encode($payload));

    $signature = hash_hmac('SHA256', "$headers_encoded.$payload_encoded", $secret, true);
    $signature_encoded = base64_encode($signature);

    // echo $headers_encoded;

    // echo $signature_encoded;

    $jwt = "$headers_encoded.$payload_encoded.$signature_encoded";

    return $jwt;
}

function validate_jwt($jwt) {
    $secretKey = 'nkvi8tOXLfQAaEJuxOveZGHpibvWpKp-2ut8xTNz2rM';
    $jwtParts = explode('.', $jwt);

    $header = base64_decode($jwtParts[0]);
    $payload = base64_decode($jwtParts[1]);
    $signature = base64_decode($jwtParts[2]);
    $expectedSignature = hash_hmac('SHA256', $jwtParts[0] . '.' . $jwtParts[1], $secretKey, true);

    $signatureValid = $signature === $expectedSignature;
    $notExpired = (json_decode($payload)->exp - time())>0;
    

    $returnValue = new stdClass();

    if ($signatureValid && $notExpired){
        $returnValue->status = true;
        $returnValue->payload = $payload;
        return $returnValue;
    }else{
        $returnValue->status = false;
        $returnValue->payload = "";
        return $returnValue;
    }
}
?>